FEM FemMesh2Mesh: Difference between revisions

From FreeCAD Documentation
No edit summary
(Docnav)
 
(28 intermediate revisions by 6 users not shown)
Line 1: Line 1:
<languages/>
<languages/>
<translate>
<translate>

<!--T:9-->
<!--T:9-->
{{Docnav
{{Docnav|[[FEM_CreateNodesSet|Nodes set]]|[[FEM_SolverCalculixCxxtools|Solver Calculix CCX tools]]|[[FEM_Module|FEM]]|IconL=FEM_CreateNodesSet.png|IconC=Workbench_FEM.svg|IconR=FEM_Solver.png}}
|[[FEM_MeshGroup|FEM mesh group]]
|[[FEM_SolverCalculixCxxtools|Solver CalculiX Standard]]
|[[FEM_Workbench|FEM]]
|IconL=FEM_MeshGroup.svg
|IconR=FEM_SolverCalculixCxxtools.svg
|IconC=Workbench_FEM.svg
}}


<!--T:1-->
<!--T:1-->
{{GuiCommand
{{GuiCommand|Name=FEM FemMesh2Mesh|MenuLocation=Mesh → FEM mesh to mesh||Workbenches=[[FEM Workbench|FEM]]|Shortcut=|SeeAlso=[[FEM_tutorial|FEM tutorial]]}}
|Name=FEM FemMesh2Mesh
|MenuLocation=Mesh → FEM mesh to mesh
|Workbenches=[[FEM_Workbench|FEM]]
|SeeAlso=[[FEM_tutorial|FEM tutorial]]
}}


== Description == <!--T:2-->
== Description == <!--T:2-->


<!--T:7-->
<!--T:7-->
This tool converts surfaces of 3D elements of a selected FEM mesh to mesh. Internally it picks FEM mesh element faces which are unique (not shared by two elements) and uses them to create faces of a mesh. Optionally it allows to create a deformed mesh caused by the action of the defined forces. This is done by adding the displacement of the FEM results to the mesh nodes.
This tool converts surfaces of 3D elements of a selected FEM mesh to mesh or converts 2D FEM mesh to mesh. Internally, it picks FEM mesh element faces that are unique (not shared by two elements) and uses them to create faces of a mesh. Optionally, it can be used to save a deformed mesh. This is done by adding the displacement of the FEM results to the mesh nodes (the scale of the displacement can be set using Python).

<!--T:3-->
Two dimensional elements from the FEM mesh are not taken into account. If you need to convert them, you can use a python script below.


==Usage== <!--T:4-->
==Usage== <!--T:4-->


<!--T:8-->
<!--T:8-->
# Select a FEM mesh object (optionally select additionally the FEM results)
# Select a FEM mesh object.
# Optionally also select the FEM results.
# Press the {{KEY|[[Image:FEM_FemMesh2Mesh.png|24px]]FEM mesh to mesh}} button
# There are several ways to invoke the command:
#* Press the {{Button|[[Image:FEM_FemMesh2Mesh.svg|16px]] [[FEM_FemMesh2Mesh|FEM mesh to mesh]]}} button.
#* Select the {{MenuCommand|Mesh → [[Image:FEM_FemMesh2Mesh.svg|16px]] FEM mesh to mesh}} option from the menu.

== Scripting == <!--T:13-->

<!--T:15-->
'''Note''': The parameter ''scale'' was {{Version|0.21}}. For older versions of FreeCAD omit it from your code.

<!--T:17-->
The cantilever example:


== Scripting == <!--T:5-->
Example:
* Load FreeCAD's 3D FEM example from the Start Workbench and run the following code
</translate>
</translate>
{{Code|code=
{{Code|code=
from os.path import join
femmesh_obj = App.ActiveDocument.getObject("Result_mesh").FemMesh
import FreeCAD as App
result = App.ActiveDocument.getObject("CalculiX_static_results")
import femmesh.femmesh2mesh
out_mesh = femmesh.femmesh2mesh.femmesh_2_mesh(femmesh_obj, result)
import Mesh
import Mesh
from femmesh import femmesh2mesh

path = join(App.getResourceDir(), "examples", "FemCalculixCantilever3D.FCStd")
doc = App.openDocument(path)
fem_mesh = doc.Box_Mesh.FemMesh
result = doc.CCX_Results
scale = 1 # displacement scale factor
out_mesh = femmesh2mesh.femmesh_2_mesh(fem_mesh, result, scale)
Mesh.show(Mesh.Mesh(out_mesh))
Mesh.show(Mesh.Mesh(out_mesh))
}}
}}
<translate>
<translate>
== Converting 2D elements == <!--T:6-->
Select a mesh and run the following python script
</translate>
{{Code|code=
import Mesh


def extend_by_triangle(i, j, k):
triangle = [input_mesh.getNodeById(element_nodes[i]),
input_mesh.getNodeById(element_nodes[j]),
input_mesh.getNodeById(element_nodes[k])]
return output_mesh.extend(triangle)

selection = FreeCADGui.Selection.getSelection()
input_mesh = App.ActiveDocument.getObject(selection[0].Name).FemMesh
output_mesh = []
for element in input_mesh.Faces:
element_nodes = input_mesh.getElementNodes(element)
if len(element_nodes) in [3, 6]: # tria3 or tria6 (ignoring mid-nodes)
extend_by_triangle(0, 1, 2)
elif len(element_nodes) in [4, 8]: # quad4 or quad8 (ignoring mid-nodes)
extend_by_triangle(0, 1, 2)
extend_by_triangle(2, 3, 0)

obj = Mesh.Mesh(output_mesh)
Mesh.show(obj)
}}
<translate>


<!--T:10-->
<!--T:10-->
{{Docnav
{{Docnav|[[FEM_CreateNodesSet|Nodes set]]|[[FEM_SolverCalculixCxxtools|Solver Calculix CCX tools]]|[[FEM_Module|FEM]]|IconL=FEM_CreateNodesSet.png|IconC=Workbench_FEM.svg|IconR=FEM_Solver.png}}
|[[FEM_MeshGroup|FEM mesh group]]
|[[FEM_SolverCalculixCxxtools|Solver CalculiX Standard]]
|[[FEM_Workbench|FEM]]
|IconL=FEM_MeshGroup.svg
|IconR=FEM_SolverCalculixCxxtools.svg
|IconC=Workbench_FEM.svg
}}


</translate>
</translate>
{{FEM Tools navi{{#translation:}}}}
{{FEM Tools navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}
{{clear}}

Latest revision as of 10:12, 2 March 2024

FEM FemMesh2Mesh

Menu location
Mesh → FEM mesh to mesh
Workbenches
FEM
Default shortcut
None
Introduced in version
-
See also
FEM tutorial

Description

This tool converts surfaces of 3D elements of a selected FEM mesh to mesh or converts 2D FEM mesh to mesh. Internally, it picks FEM mesh element faces that are unique (not shared by two elements) and uses them to create faces of a mesh. Optionally, it can be used to save a deformed mesh. This is done by adding the displacement of the FEM results to the mesh nodes (the scale of the displacement can be set using Python).

Usage

  1. Select a FEM mesh object.
  2. Optionally also select the FEM results.
  3. There are several ways to invoke the command:
    • Press the FEM mesh to mesh button.
    • Select the Mesh → FEM mesh to mesh option from the menu.

Scripting

Note: The parameter scale was introduced in version 0.21. For older versions of FreeCAD omit it from your code.

The cantilever example:

from os.path import join
import FreeCAD as App
import Mesh
from femmesh import femmesh2mesh

path = join(App.getResourceDir(), "examples", "FemCalculixCantilever3D.FCStd")
doc = App.openDocument(path)
fem_mesh = doc.Box_Mesh.FemMesh
result = doc.CCX_Results
scale = 1  # displacement scale factor
out_mesh = femmesh2mesh.femmesh_2_mesh(fem_mesh, result, scale)
Mesh.show(Mesh.Mesh(out_mesh))